import * as react from 'react';
import * as _webbo_ui_theme from '@webbo-ui/theme';
import { Reason, RenderInputProps } from './autocomplete.mjs';
export { AutocompleteProps } from './autocomplete.mjs';
import { OptionProps } from './option.mjs';
export { mapInputProps } from './map-input-props.mjs';
import '@webbo-ui/popper';
import '@webbo-ui/input';

declare const Autocomplete: <Value extends object, Multiple extends boolean = false, DisableClearable extends boolean = false>(props: _webbo_ui_theme.AutocompleteVariantProps & Omit<react.HTMLAttributes<HTMLUListElement>, "defaultValue" | "children"> & {
    disabled?: boolean | undefined;
    classNames?: _webbo_ui_theme.ClassNames<{
        listbox: string;
        option: string;
        noOptions: string;
        loading: string;
        group: string;
        groupHeader: string;
        groupItems: string;
    }> | undefined;
    offset?: number | undefined;
    options: Value[];
    isOpen?: boolean | undefined;
    onOpenChange?: ((open: boolean) => void) | undefined;
    defaultOpen?: boolean | undefined;
    getOptionDisabled?: ((option: Value) => boolean) | undefined;
    disableCloseOnSelect?: boolean | undefined;
    getOptionLabel?: ((option: Value) => string) | undefined;
    getOptionKey?: ((options: Value) => string) | undefined;
    noOptionsText?: string | undefined;
    loading?: boolean | undefined;
    loadingText?: string | undefined;
    groupBy?: ((option: Value) => string) | undefined;
    children?: ((props: {
        groupedOptions: Record<string, OptionProps<Value>[]> | null;
        options: OptionProps<Value>[] | null;
    }) => react.ReactNode) | undefined;
    inputValue?: string | undefined;
    onInputChange?: ((val: string) => void) | undefined;
    filterOptions?: ((options: Value[], inputValue: string) => Value[]) | undefined;
} & (Multiple extends true ? {
    multiple: Multiple;
    defaultValue?: Value[] | undefined;
    value?: Value[] | undefined;
    onChange?: ((event: {
        target: {
            value: Value[];
        };
    }, reason: Reason, value: Value[]) => void) | undefined;
    disableClearable?: DisableClearable | undefined;
    renderInput: (props: RenderInputProps<Value[]>) => react.ReactNode;
} : DisableClearable extends true ? {
    multiple?: Multiple | undefined;
    defaultValue?: Value | undefined;
    value?: Value | undefined;
    onChange?: ((event: {
        target: {
            value: Value;
        };
    }, reason: Reason, value: Value) => void) | undefined;
    disableClearable: DisableClearable;
    renderInput: (props: RenderInputProps<Value>) => react.ReactNode;
} : {
    multiple?: Multiple | undefined;
    defaultValue?: Value | undefined;
    value?: Value | null | undefined;
    onChange?: ((event: {
        target: {
            value: Value | null;
        };
    }, reason: Reason, value: Value | null) => void) | undefined;
    disableClearable?: DisableClearable | undefined;
    renderInput: (props: RenderInputProps<Value | null>) => react.ReactNode;
}) & react.RefAttributes<HTMLUListElement>) => react.ReactNode;
declare const Option: react.ForwardRefExoticComponent<OptionProps<object> & {
    children?: react.ReactNode;
} & react.RefAttributes<HTMLLIElement>>;

export { Autocomplete, Option, OptionProps, Reason };
